//

package StockInformation;

import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.Collections;
import java.util.Iterator;
import java.util.LinkedList;
import java.util.List;

import javax.persistence.EntityManager;
import javax.persistence.EntityManagerFactory;
import javax.persistence.PersistenceContext;



import javax.ejb.*;
import javax.persistence.Query;



@Stateful(name="itemdetails", mappedName="IteamdetailsBeanJNDI")

public class IteamdetailsBean implements Iteamdetails{

       
	@PersistenceContext(name="STOCKDETAILS-ejbPU")
        
	EntityManager em;
                

	public IteamdetailsBean(){}



	public void createIteamdetails(){

		try{
			Iteamdetailsent iteamdetailsent=new Iteamdetailsent();

			iteamdetailsent.setItmid("t2");
			iteamdetailsent.setItmname("Taddy bear");
                       
			//a call to the persit manager will result in inserting the argument
			em.persist(iteamdetailsent);

		}catch(Exception ex){

			System.err.println("Can not insert new item details");
			
		}

	}


        



	
                                          
        //retrieving by it's iteam ID
	public Iteamdetailsent Itemsbyid(String itmid){
            Iteamdetailsent iteamdetailsent=new Iteamdetailsent();
		try{
			
			 iteamdetailsent=em.find(Iteamdetailsent.class, itmid);
                        //.setParameter("yes", "Discount").getResultList();

		}catch(Exception ex){
			System.err.println("Can not access DB");

		}//end of catch
                 return iteamdetailsent;
	}//end of  Itemsbyid()

        
        //retrieving items by name
	public List<Iteamdetailhlp> Itemname(String itmname){
        //public String AllItemname(String itemnames){
             List<Iteamdetailsent> iteamdetailsent=null;
                    
		try{
			
			iteamdetailsent=(List<Iteamdetailsent>) em.createNamedQuery("Getitemswithname").setParameter("itmname", itmname).getResultList();
                        //.setParameter("yes", "Discount").getResultList();

		}catch(Exception ex){
			System.err.println("Can not get items details by name. Name entered not recogniced");

		}//end of catch
                 return copyToDetails(iteamdetailsent);
	}//end of Itemname(String itmname)



            //retrieving Bargain Corner items
          public List<Iteamdetailhlp> BargainCornItems(String DeptID){
            List<Iteamdetailsent> iteamdetailsent=null;
		try{
                   iteamdetailsent=(List<Iteamdetailsent>)em.createNamedQuery("GetBargaincornitems").setParameter("DeptID",DeptID).getResultList();
		
                 return   copyToDetails(iteamdetailsent);
        
                }catch (Exception ex) {
                    System.err.println("Can not get items details by bargain dept id. data entered not recogniced");
            throw new EJBException(ex);
                }
          }
          
                  //retrieving Bargain Corner items
          public List<Iteamdetailhlp> Selfserver(String DeptID){
            List<Iteamdetailsent> iteamdetailsent=null;
		try{
                   iteamdetailsent=(List<Iteamdetailsent>)em.createNamedQuery("GetSelfserveitems").setParameter("DeptID",DeptID).getResultList();
		
                 return   copyToDetails(iteamdetailsent);
        
                }catch (Exception ex) {
                    System.err.println("Can not get items details by bargain dept id. data entered not recogniced");
            throw new EJBException(ex);
                }
          }
          
                  //retrieving Collectpoint items
          public List<Iteamdetailhlp> Collectpoint(String deptID){
            List<Iteamdetailsent> iteamdetailsent=null;
		try{
                   iteamdetailsent=(List<Iteamdetailsent>)em.createNamedQuery("GetCollectionitems").setParameter("deptID",deptID).getResultList();
		
                 return   copyToDetails(iteamdetailsent);
        
                }catch (Exception ex) {
                    System.err.println("Can not get items details by bargain dept id. data entered not recogniced");
            throw new EJBException(ex);
                }
          }
	
        //for discount items
        public List<Iteamdetailhlp> DisCountitems(){
            List<Iteamdetailsent> iteamdetailsent=null;
           
		try{
                   iteamdetailsent=(List<Iteamdetailsent>)em.createNamedQuery("GetAlldiscountitems").getResultList();
		
                 return   copyToDetails(iteamdetailsent);
                }catch (Exception ex) {
            throw new EJBException(ex);
        }
			//System.err.println("Can not Could not get all discount items");}//end of catch
                        
                           // throw new EJBException(ex);
            // return iteamdetailsent;
           
                // return ;
	}//end of DisCountitems()

        
        //To retrieve all items
        public List<Iteamdetailhlp> AllItems(){
            List<Iteamdetailsent> iteamdetailsent=null;
           
		try{
                   iteamdetailsent=(List<Iteamdetailsent>)em.createNamedQuery("GetAllItems").getResultList();
		
                 return   copyToDetails(iteamdetailsent);
                }catch (Exception ex) {
            throw new EJBException(ex);
        }
        }//end of AllItems
        
        //retrieving items by a particular department
        public List<Iteamdetailhlp> DeptItems(String Departmentname){
             List<Iteamdetailsent> iteamdetailsent=null;
                    
		try{
			
			iteamdetailsent=(List<Iteamdetailsent>) em.createNamedQuery("GetDepartmentitems").setParameter("Departmentname", Departmentname).getResultList();
                   
		}catch(Exception ex){
			System.err.println("Can not get items details by Department entered. Name entered not recogniced");

		}//end of catch
                 return copyToDetails(iteamdetailsent);
	}////end of DeptItems()
        
        //retrieving items by a particular department
        public List<Iteamdetailsent> DeptItems2(){
             List<Iteamdetailsent> iteamdetailsent=null;
                 //Iteamdetailsent iteamdetailsent=null;   
		try{
			
			//iteamdetailsent=(List<Iteamdetailsent>) em.createNamedQuery("GetDepartmentitems").setParameter("Departmentname", Departmentname).getResultList();
                    iteamdetailsent=(List<Iteamdetailsent>) em.createNamedQuery("GetDepartmentitems2").getResultList();
                            //setParameter("Departmentname", Departmentname).getResultList();
                   
		}catch(Exception ex){
			System.err.println("Can not get items details by Department entered. Name entered not recogniced");

		}//end of catch
                 return iteamdetailsent;
                     //copyToDetails(iteamdetailsent);
	}////end of DeptItems()

        //retrieving items by description
    public List<Iteamdetailhlp> DescriptItem(String description){
             List<Iteamdetailsent> iteamdetailsent=null;
                    
		try{
			
			iteamdetailsent=(List<Iteamdetailsent>) em.createNamedQuery("GetItemsbydescption").setParameter("description", description).getResultList();
                   
		}catch(Exception ex){
			System.err.println("Can not get items details by Description entered. Name entered not recogniced");

		}//end of catch
                 return copyToDetails(iteamdetailsent);
	}//end of DescriptItem

     
     //retrieving items by description/ item code or item name
     public List<Iteamdetailhlp> Despcodename(String param){
             List<Iteamdetailsent> iteamdetailsent=null;
             //Iteamdetailsent iteamdetailsents=null;
                 if (param!=null){
		try{
			
			iteamdetailsent=(List<Iteamdetailsent>) em.createNamedQuery("GetItemsbydescodename").setParameter("param", param).getResultList();
                        //iteamdetailsent=(List<Iteamdetailsent>) em.createNamedQuery("Getitemswithname").setParameter("itmname", itmname).getResultList();
		}catch(Exception ex){
			System.err.println("Can not get items details by Description/code or name entered. Name entered not recogniced");}}

		
                 return copyToDetails(iteamdetailsent);
	}//end of Despcodename



	public List<Iteamdetailhlp> getitemsfororder(List<Iteamdetailsent> iteamdetailsents) {
                 List<Iteamdetailhlp> detailsList = new LinkedList<Iteamdetailhlp>();
                 
                 Iterator<Iteamdetailsent> i = iteamdetailsents.iterator();
                              while (i.hasNext()) {
                                    Iteamdetailsent iteamdetailsent = (Iteamdetailsent) i.next();
                                     Iteamdetailhlp iteamdetailhlp=new Iteamdetailhlp(
                                        
                                        iteamdetailsent.getitmid(),
                                         iteamdetailsent.getitmname(),
                                          iteamdetailsent.getdescription(),
                                           iteamdetailsent.getitemsize(),
                                           iteamdetailsent.getcolour(),
                                           iteamdetailsent.getprice());
                                           iteamdetailsent.getDeptID();
                                detailsList.add(iteamdetailhlp);
                                }

                                 return detailsList;
                }


        
        //private List<Iteamdetailhlp> copyToDetails(List<Iteamdetailsent> iteamdetailsents) {
        private List<Iteamdetailhlp> copyToDetails(List<Iteamdetailsent> iteamdetailsents) {
                 List<Iteamdetailhlp> detailsList = new LinkedList<Iteamdetailhlp>();
                 
                 Iterator<Iteamdetailsent> i = iteamdetailsents.iterator();
                              while (i.hasNext()) {
                                    Iteamdetailsent iteamdetailsent = (Iteamdetailsent) i.next();
                                     Iteamdetailhlp iteamdetailhlp=new Iteamdetailhlp(
                                        
                                        iteamdetailsent.getitmid(),
                                         iteamdetailsent.getitmname(),
                                          iteamdetailsent.getdescription(),
                                           iteamdetailsent.getitemsize(),
                                           iteamdetailsent.getcolour(),
                                           iteamdetailsent.getprice());
                                           iteamdetailsent.getDeptID();
                                detailsList.add(iteamdetailhlp);
                                }

                                 return detailsList;
                }

    
        

}