//
package StockInformation;


import java.io.Serializable;
import java.util.Collection;
import java.util.List;
import javax.ejb.*;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Id;
import javax.persistence.IdClass;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToMany;
import javax.persistence.ManyToOne;
import javax.persistence.NamedQueries;
import javax.persistence.NamedQuery;
import javax.persistence.OneToMany;
import javax.persistence.Table;
import javax.persistence.OneToOne;


@Entity
@Table(name="ITEMS")

@NamedQueries({
    @NamedQuery(name = "GetAlldiscountitems",query = "SELECT i FROM Iteamdetailsent i where i.Discount='yes'"),
    //where i.Discount like 'yes'
    @NamedQuery(name = "Getitemswithname",query = "SELECT i FROM Iteamdetailsent i WHERE i.itmname= :itmname"),
    
    @NamedQuery(name = "GetBargaincornitems",query = "SELECT i FROM Iteamdetailsent i JOIN i.departmentent d WHERE d.deptID=:deptID"),
    @NamedQuery(name = "GetCollectionitems",query = "SELECT i FROM Iteamdetailsent i JOIN i.departmentent d WHERE d.deptID=:deptID"),
    @NamedQuery(name = "GetSelfserveitems",query = "SELECT i FROM Iteamdetailsent i JOIN i.departmentent d WHERE d.deptID=:deptID"),
    
    //@NamedQuery(name = "GetDepartmentitems",query = "SELECT i FROM Iteamdetailsent i WHERE i.depid= :depid"),
     @NamedQuery(name = "GetDepartmentitems",query = "SELECT i, d FROM Iteamdetailsent i, Departmentent d WHERE d.Departmentname=:Departmentname"),
     ///@NamedQuery(name = "GetBargaincornitems",query = "SELECT i FROM Iteamdetailsent i JOIN i.departmentent d WHERE d.DeptID=:DeptID"),
    //@NamedQuery(name = "GetItemsbydescption",query = "SELECT i FROM Iteamdetailsent i WHERE i.description= :description OR i.itmid=:itmid OR i.itmname=:itmname"),
     @NamedQuery(name = "GetItemsbydescption",query = "SELECT i FROM Iteamdetailsent i WHERE i.description= :description"),
    //@NamedQuery(name = "GetItemsbydescption2",query = "SELECT i FROM Iteamdetailsent i WHERE i.description like('%',CONCAT(:description,'%') OR i.itmid like('%',CONCAT(:itmid,'%') OR i.itmname like('%',CONCAT(:itmname,'%')))"),
    @NamedQuery(name = "GetItemsbydescodename",query = "SELECT i FROM Iteamdetailsent i WHERE i.description =:param OR i.itmid =:param OR i.itmname =:param"),
    @NamedQuery(name = "GetAllItems",query = "SELECT i FROM Iteamdetailsent i"),
    @NamedQuery(name = "GetDepartmentitems2",query = "SELECT i FROM Iteamdetailsent i")
 })
 

public class Iteamdetailsent implements Serializable{

	
	@Id
	@Column(name="ITMID", nullable=false)
	private String itmid;
	@Column(name="ITMNAME", nullable=true)
	private String itmname;
	@Column(name="DESCRIPTION", nullable=true)
	private String description;
	@Column(name="COLOUR", nullable=true)
	private String colour;
	@Column(name="PRICE", nullable=true)
	private String price;
	@Column(name="ITEMSIZE", nullable=true)
	private String itemsize;
	
	@Column(name="DISCOUNT", nullable=true)
	private String discount;

        @ManyToOne()
        @JoinColumn(name="DeptID")
        private Departmentent departmentent;


	@OneToMany
       
    	private Collection<Iteamdetailsent> iteamdetailsent;

	//for customer orders.  Many items for
	//many orders
	
	

	public Iteamdetailsent(){
	}

	public Iteamdetailsent(String itmid){}


	public Iteamdetailsent(String itmid,String itmname){}
	
	public Iteamdetailsent(String itmid,String itmname, String description, String colour, String price, String itemsize, Departmentent departmentent){
            this.itmid=itmid;
            this.itmname =itmname;
            this.description=description;
            this.colour=colour;
            this.price=price; 
            this.itemsize=itemsize; 
            this.departmentent=departmentent;
        }

	//define all hte get and set methods

	
	
	public String getItmid(){
		return itmid;}
	
	public void setItmid(String itmid){
		this.itmid=itmid;}
	
	
	public String getItmname(){
		return itmname;}
	
	public void setItmname(String itmname){
		this.itmname=itmname;}
	

	public String getDescription(){
		return description;}
	
	public void setDescription(String description){
		this.description=description;}

	public String getColour(){
		return colour;}
	
	public void setColour(String colour){
		this.colour=colour;}


	public String getPrice(){
		return price;}
	
	public void setPrice(String price){
		this.price=price;}

	public String getItemsize(){
		return itemsize;}
	
	public void setItemsize(String itemsize){
		this.itemsize=itemsize;}

	public Departmentent getDeptID(){
		return departmentent;}
	
	public void setDeptID(Departmentent departmentent){
		this.departmentent=departmentent;}
	
	public String getDiscount(){
		return discount;}
	
	public void setDiscount(String discount){
		this.discount=discount;}
        
        
        public String toString() {
        String s = itmid +  "  " + itmname +"  " + description + "  "+ itemsize + " " + colour + "  "  + price + "  " + departmentent;

        return s;
    }


}